<?php // Custom MainMenu extension...

function display_main_menu($menu_name)
{
global $database, $my;
$mymenu_content = <<<EOT

<script language="JavaScript"><!--

var MENU_ITEMS = [

EOT;

$database->setQuery("SELECT * FROM #__menu WHERE menutype = '$menu_name' AND published ='1' AND access <= $my->gid ORDER BY ordering");

$menus = $database->loadObjectList();	// mainmenu list

$subs = array();	// sub menus

// first pass to collect sub-menu items

foreach ($menus as $row)
{
	if ($row->parent)
	{
		if (!array_key_exists( $row->parent, $subs ))
		{
			$subs[$row->parent] = array();
		}
		$subs[$row->parent][] = $row;
	}
}
foreach ($menus as $row)
{ 
	// second pass to insert main-menu items
	if ($row->parent == 0 && (trim( $row->link ) || array_key_exists( $row->id, $subs ))) 
	{
		$name = addslashes( $row->name );
		$alt = addslashes( $row->name );
		$link = $row->link ? "$row->link" : "null";

		if ($row->type != "url")
		{
			$link .= "&Itemid=$row->id";
		}
		
		$link_sef = "'".sefRelToAbs($link)."'";
		
		$mymenu_content .= "\n	['$name', $link_sef,";
		
		
		if (array_key_exists( $row->id, $subs ))
		{
			$mymenu_content .= ',';

			foreach ($subs[$row->id] as $sub)
			{
				// third pass to insert sub-menu items

				$name = addslashes( $sub->name );

				$alt = addslashes( $sub->name );

				$link = $sub->link ? "$sub->link" : "null";

				if ($sub->type != "url")
				{
				
					$link .= "&Itemid=$sub->id";

				}

				$link_sef = "'".sefRelToAbs($link)."'";

				$mymenu_content .= "\n	['$name', $link_sef,";

				if (array_key_exists( $sub->id, $subs ))
				{
					
					$mymenu_content .= ',';

					foreach ($subs[$sub->id] as $sub2) 
					{ 
						// forth pass to insert subsub-menu items

						$name = addslashes( $sub2->name );

						$alt = addslashes( $sub2->name );

						$link = $sub2->link ? "$sub2->link" : "null";

						if ($sub2->type != "url")
						{
							$link .= "&Itemid=$sub2->id";

						}

						$link_sef = "'".sefRelToAbs($link)."'";

						$mymenu_content .= "\n	['$name', $link_sef,";
						
						if (array_key_exists( $sub2->id, $subs ))
						{
							?>
							<!--<script language="javascript">
								alert("<?//echo $sub->name;?>");
							</script>
							-->
							<?
							$mymenu_content .= ',';

							foreach ($subs[$sub2->id] as $sub3) 
							{ 
								// fifth pass to insert subsub-menu items

								$name = addslashes( $sub3->name );

								$alt = addslashes( $sub3->name );

								$link = $sub3->link ? "$sub3->link" : "null";

								if ($sub3->type != "url")
								{
									$link .= "&Itemid=$sub3->id";

								}

								$link_sef = "'".sefRelToAbs($link)."'";

								$mymenu_content .= "\n	['$name', $link_sef],";
							}
						}
						$mymenu_content .= "],";
					}
				}
				$mymenu_content .= "],";
			}
		}
		
		$mymenu_content .= "],";
	}
}

$mymenu_content .= "];\n";

$mymenu_content .= "-->
</script>\n";

echo $mymenu_content;
}
?>